#include <windows.h>
#include <tchar.h>

#include <stdarg.h>
#include <squirrel.h>
#include <sqstdio.h>
#include <sqstdmath.h>
#include <sqstdstring.h>
#include <sqstdaux.h>
#include <sqstdblob.h>

#include <sqthread.h>

using namespace SqPlus;

/**
 * Oo͗p
 * @param v Squirrel VM
 * @param format w
 */
static void PrintFunc(HSQUIRRELVM v, const SQChar* format, ...)
{
	va_list args;
	va_start(args, format);
	vwprintf(format, args);
	va_end(args);
}

using namespace sqobject;


class Base : public Object {

public:
	Base() {
	}

	int getValue() {
		return 10;
	}

	static int constructor(HSQUIRRELVM v) {
		return PostConstruct<Base>(v,new Base(),ReleaseClassPtr<Base>::release);
	}
};


class Deliv : public Base {

public:
	Deliv() {
	}

	int getValue2() {
		return 20;
	}

	static int constructor(HSQUIRRELVM v) {
		return PostConstruct<Deliv>(v,new Deliv(),ReleaseClassPtr<Deliv>::release);
	}
};

// XXX namespace ̎w肪܂ƔƂۂ̂Œ
DECLARE_INSTANCE_TYPE(Object);
DECLARE_INSTANCE_TYPE(Thread);
DECLARE_INSTANCE_TYPE(Base);
DECLARE_INSTANCE_TYPE(Deliv)

int
_tmain(int argc, TCHAR **argv)
{
	// squirrel 
	SquirrelVM::Init();

	HSQUIRRELVM v = SquirrelVM::GetVMPtr();
#ifdef DEBUG
	// fobO\L
	sq_notifyallexceptions(v, SQTrue);
#endif
	// print ̓o^
	sq_setprintfunc(v, PrintFunc);
	
	// e{Cu̓o^
	sqstd_register_iolib(v);
	sqstd_register_bloblib(v);
	sqstd_register_mathlib(v);
	sqstd_register_stringlib(v);
	sqstd_seterrorhandlers(v);
	
	// Object/Thread o^
	Object::registClass();
	Thread::registClass();

	{
		// NXo^
		SQClassDef<Base,Object> base(_SC("Base"));
		base.staticFunc(&Base::constructor, _SC("constructor"));
		base.func(&Base::getValue, _SC("getValue"));
		
		SQClassDef<Deliv,Base> deliv(_SC("Deliv"));
		deliv.staticFunc(&Deliv::constructor, _SC("constructor"));
		deliv.func(&Deliv::getValue2, _SC("getValue2"));
	}
	
	// R}hCp[XĂꂼ fork s
	for (int i=1;i<argc;i++) {
		SqPlus::SquirrelFunction<int>(_SC("fork"))(NULL,argv[i]);
	}
	
	// Xbhs
	while (Thread::main(::GetTickCount()) > 0);
	
	SquirrelVM::Shutdown();
}
