/*
 * copyright (c)2009 http://wamsoft.jp
 * zlib license
 */
#include "sqobjectinfo.h"
#include "sqobject.h"
#include "sqthread.h"

namespace sqobject {

// e
void
ObjectInfo::clear()
{
	sq_release(v,&obj);
	v = NULL;
	sq_resetobject(&obj);
}

// X^bN擾
void
ObjectInfo::getStack(HSQUIRRELVM v, int idx)
{
	clear();
	this->v = v;
	sq_getstackobj(v, idx, &obj);
	sq_addref(v, &obj);
}

// RXgN^
ObjectInfo::ObjectInfo() : v(NULL) {
	sq_resetobject(&obj);
}

// RXgN^
ObjectInfo::ObjectInfo(HSQUIRRELVM v, int idx) : v(v)
{
	sq_resetobject(&obj);
	sq_getstackobj(v, idx, &obj);
	sq_addref(v, &obj);
}

// Rs[RXgN^
ObjectInfo::ObjectInfo(const ObjectInfo &orig)
{
	v   = orig.v;
	obj = orig.obj;
	sq_addref(v, &obj);
}

// 
ObjectInfo& ObjectInfo::operator =(const ObjectInfo &orig)
{
	clear();
	v = orig.v;
	obj = orig.obj;
	sq_addref(v, &obj);
	return *this;
}

// fXgN^
ObjectInfo::~ObjectInfo()
{
	clear();
}

// XbhH
bool
ObjectInfo::isThread() const
{
	return sq_isthread(obj);
}

// XbhH
bool
ObjectInfo::isSameThread(const HSQUIRRELVM v) const
{
	return sq_isthread(obj) && obj._unVal.pThread == v;
}

// Xbh擾
ObjectInfo::operator HSQUIRRELVM() const
{
	HSQUIRRELVM vm = sq_isthread(obj) ? obj._unVal.pThread : NULL;
	return vm;
}
	
// IuWFNgPUSH
void
ObjectInfo::push(HSQUIRRELVM v) const
{
	sq_pushobject(v, obj);
}

// ---------------------------------------------------
// delegate p
// ---------------------------------------------------

// delegate Ƃċ@\邩ǂ
bool
ObjectInfo::isDelegate()
{
	return v && (sq_isinstance(obj) || sq_istable(obj));
}

// bindenv 邩ǂ
bool
ObjectInfo::isBindDelegate()
{
	return v && (sq_isinstance(obj));
}

// ---------------------------------------------------
// IuWFNg擾
// ---------------------------------------------------

// CX^X[U|C^擾
Thread *
ObjectInfo::getThread()
{
	if (sq_isinstance(obj)) {
		sq_pushobject(v, obj);
		Thread *ret = SqPlus::GetInstance<Thread,false>(v, -1);
		sq_pop(v,1);
		return ret;
	}
	return NULL;
}

// CX^X[U|C^擾
Object *
ObjectInfo::getObject()
{
	if (sq_isinstance(obj)) {
		sq_pushobject(v, obj);
		Object *ret = SqPlus::GetInstance<Object,false>(v, -1);
		sq_pop(v, 1);
		return ret;
	}
	return NULL;
}
	
// ---------------------------------------------------
// waitp\bh
// ---------------------------------------------------

bool
ObjectInfo::isSameString(const SQChar *str) const
{
	if (str && sq_isstring(obj)) {
		const SQChar *mystr;
		sq_pushobject(v, obj);
		sq_getstring(v, -1, &mystr);
		sq_pop(v, 1);
		return mystr && scstrcmp(str, mystr) == 0;
	}
	return false;
}

};
