/*
 * copyright (c)2009 http://wamsoft.jp
 * zlib license
 */
#ifndef __SQTHREAD_H__
#define __SQTHREAD_H__

#ifndef SQTHREADNAME
#define SQTHREADNAME _SC("Thread")
#endif

#include "sqobject.h"

namespace sqobject {

class Thread : public Object {

protected:
	long _currentTick; //< ̃Xbh̎s

	// Xbhf[^
	ObjectInfo _thread;

	// ҂Ώ
	std::vector<ObjectInfo> _waitList;
	// ҂
	SQInteger _waitTimeout;

	// ҂^CAEg
	ObjectInfo _waitResult;

	/**
	 * Xbh
	 */
	enum ThreadStatus {
		THREAD_STOP,  // ~
		THREAD_RUN,   // 쒆
		THREAD_WAIT,  // ҂
		THREAD_END,   // I
	} _status;

	/**
	 * @return ҂
	 */
	bool isWait();

	/**
	 * @return YXbhƌ݊Ǘ̃XbhvĂ true
	 */
	bool isSameThread(HSQUIRRELVM v);

	/**
	 * gKɑ΂҂
	 * @param name gK
	 * @return YIuWFNg҂Ăꍇ true
	 */
	bool notifyTrigger(const SQChar *name);


public:
	// RXgN^
	Thread();
	
	// fXgN^
	~Thread();

protected:
	/**
	 * IuWFNgɑ΂҂NA
	 * @param status LZ̏ꍇ true
	 */
	void _clearWait();

	/**
	 * j
	 */
	void _clear();
	
	// ------------------------------------------------------------------
	//
	// Object ̐p
	//
	// ------------------------------------------------------------------
	
public:
	/**
	 * IuWFNgɑ΂҂
	 * @param target ҂Ώ
	 * @return YIuWFNg҂Ăꍇ true
	 */
	bool notifyObject(Object *target);

	// ------------------------------------------------------------------
	//
	// \bh
	//
	// ------------------------------------------------------------------

public:
	/**
	 * ҂o^
	 */
	SQRESULT wait(HSQUIRRELVM v);

	/**
	 * wait̃LZ
	 */
	void cancelWait();

	/**
	 * sJn
	 * @param func sΏۃt@NVB̏ꍇYXNvgǂݍ
	 */
	SQRESULT exec(HSQUIRRELVM v);

	/**
	 * sI
	 */
	void exit();

	/**
	 * s~
	 */
	void stop();

	/**
	 * sĊJ
	 */
	void run();

	/**
	 * @return sXe[^X
	 */
	int getStatus();

	/**
	 * @return ݎ
	 */
	int getCurrentTick() {
		return _currentTick;
	}

	// ------------------------------------------------------------------
	//
	// s
	//
	// ------------------------------------------------------------------
	
protected:
	/**
	 * Xbh̃C
	 * @param diff oߎ
	 * @return XbhsIȂ true
	 */
	bool _main(long diff);

public:
	/*
	 * sC[v
	 * @param tick tickl
	 * ݑ݂Xbh𑍂Ȃ߂łPxsB
	 * VXe{̂̃C[v(Cxg{摜)
	 * 1xĂяoƂŋ@\Bꂼ̃Xbh́A
	 * 疾I suspend() ܂ waitñ\bhĂяoď
	 * ̃XbhɈϏKvB
	 * @return 
	 */
	static int main(long tick);

	/**
	 * Xbh̔j
	 */
	static void done();

	// -------------------------------------------------------------
	//
	// O[oXbhp@\
	//
	// -------------------------------------------------------------
	
protected:
	static std::vector<ObjectInfo> threadList; //< Xbhꗗ
	static bool first;        //< Ăяo
	static long prevTick;     //< ǑĂяo
	static long currentTick;  //< ̌Ăяo

	/**
	 * XbhsJno^
	 * @param v SquirrelX^bN 1ԂɃXbhIuWFNg͂Ă͂
	 */
	static void entryThread(HSQUIRRELVM v);

	// -------------------------------------------------------------
	// O[o\bhp
	// -------------------------------------------------------------

	/**
	 * ݎ̎擾
	 */
	static SQRESULT global_getCurrentTick(HSQUIRRELVM v);

	/*
	 * @return ݂̃XbhԂ
	 */
	static SQRESULT global_getCurrentThread(HSQUIRRELVM v);
	
	/*
	 * @return ݂̃XbhꗗԂ
	 */
	static SQRESULT global_getThreadList(HSQUIRRELVM v);

	/*
	 * XNvgVXbhƂĎs
	 *  return Thread(func); 
	 * @param func XbhŎst@NV
	 * @return VXbh
	 */
	static SQRESULT global_fork(HSQUIRRELVM v);

	/**
	 * @return ݎs̃XbhIuWFNg(Thread*)
	 */
	static Thread *getCurrentThread(HSQUIRRELVM v);
	
	/**
	 * XNvg؂ւ
	 * @param func XbhŎst@NV
	 */
	static SQRESULT global_exec(HSQUIRRELVM v);

	/**
	 * sXbh̏I
	 */
	static SQRESULT global_exit(HSQUIRRELVM v);

	/**
	 * sXbh̏҂
	 * @param target int:ԑ҂(ms), string:gK҂, obj:IuWFNg҂
	 * @param timeout ^CAEg(ȗ͖ɑ҂)
	 * @return ҂LZꂽ true
	 */
	static SQRESULT global_wait(HSQUIRRELVM v);

	/**
	 * SXbhւ̃gKʒm
	 * @param name ҂gK
	 */
	static SQRESULT global_trigger(HSQUIRRELVM v);

	// ------------------------------------------------------------------
	//
	// sqplus o^p
	//
	// ------------------------------------------------------------------

protected:
	/**
	 * squirrelpRXgN^
	 */
	static SQRESULT constructor(HSQUIRRELVM v);

	/**
	 * squirrel [Xp
	 */
	SQ_DECLARE_RELEASE(Thread);
	
public:
	/**
	 * NX̓o^
	 */
	static void registClass();
};

};

#endif
